﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private nid As Int = 1
	Private lock As PhoneWakeState
	Dim pe As PhoneEvents
	Dim PhoneId As PhoneId
	Dim p As PhoneSms
End Sub

Sub Service_Create
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	pe.InitializeWithPhoneState("pe",PhoneId)
	lock.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(nid, CreateNotification("..."))
	'StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
	'Log("Starting")
End Sub

Sub pe_SmsDelivered (PhoneNumber As String, Intent As Intent)
	Log("pe_SmsDelivered: PhoneNumber=" & PhoneNumber & ", message_id=" & Intent.GetExtra("message_id"))
End Sub

Sub pe_SmsSentStatus (Success As Boolean, ErrorMessage As String, PhoneNumber As String, Intent As Intent)
	Log("pe_SmsSentStatus: PhoneNumber=" & PhoneNumber & ", Success=" & Success & ", message_id=" & Intent.GetExtra("message_id"))
End Sub

Sub Notify(msg As String)
	Dim n As Notification = CreateNotification( msg )
	n.Notify(nid)
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("Monitoring", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	pe.StopListening()
	lock.ReleasePartialLock
End Sub

Sub PE_PhoneStateChanged (State As String, incomingnumber As String, Intent As Intent)
	'When incomingnumber is sent through to the p.send() function it comes through as empty
	Select State
		Case "RINGING"
			Log("phone state changed " & State & " from " & incomingnumber )
			Notify( "Ringing " & incomingnumber )
			CallSubDelayed2(Main, "ShowIncomingNumber", incomingnumber)
			SendSMS( incomingnumber)
	End Select
End Sub

Private Sub SendSMS(phnumber As String)

	Log("in SendSMS with " & phnumber)

	Dim msg As String
	msg = "Texting you at " & phnumber
	
	'The line below does not work because when it is uncommented phnumber is empty
	'p.send( phnumber , msg )

	'The line below works perfectly even when the hardcoded number is the same as phnumber and phnumber is NOT empty
	p.send( "+19999999999", msg )

End Sub